package com.muzhi.tb.controller;

import com.muzhi.tb.service.TbService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

/**
 * @Author ZhangKan
 * @Data 15:03
 */

@Api(description = "TB接口")
@RestController
@RequestMapping("/tbservice")
public class TbController {

    @Autowired
    private TbService tbService;

    //获取TB中的企业成员列表（TB应用）
    @ApiOperation(value = "获取TB中的企业成员列表（TB应用）")
    @GetMapping("getUserList")
    public String getUserList(){

        String userList = tbService.getUserList();
        return userList;
    }

    @GetMapping("userGet")
    public String userGet(String userId){

        String s = tbService.userGet(userId);
        return s;
    }

    //接收TB推送的数据
    @PostMapping("callback")
    public String callback(@RequestBody Map body) throws Exception{

        String s = tbService.callBack(body);
        System.out.println(s);
        return s;
    }

    //创建宜搭项目表单
//    @PostMapping("createYiDaXM")
//    public String createYiDaXM() throws Exception{
//
//        String yiDaXM = tbService.createYiDaXM();
//        System.out.println(yiDaXM);
//        return yiDaXM;
//    }
}
