package com.muzhi.tb.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.aliyun.dingtalkyida_1_0.models.StartInstanceHeaders;
import com.aliyun.dingtalkyida_1_0.models.StartInstanceRequest;
import com.aliyun.tea.TeaException;
import com.aliyun.teautil.models.RuntimeOptions;
import com.dingtalk.api.DefaultDingTalkClient;
import com.dingtalk.api.DingTalkClient;
import com.dingtalk.api.request.OapiV2UserGetbymobileRequest;
import com.dingtalk.api.response.OapiV2UserGetbymobileResponse;
import com.muzhi.tb.service.AccessTokenService;
import com.muzhi.tb.service.YiDaService;
import com.taobao.api.ApiException;
import okhttp3.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class YiDaServiceImpl implements YiDaService {

    @Autowired
    private AccessTokenService accessTokenService;

    public static String body = null;
    public static String result = null;


    /**
     * 使用 Token 初始化账号Client
     * @return Client
     * @throws Exception
     */
    public static com.aliyun.dingtalkyida_1_0.Client createClient() throws Exception {
        com.aliyun.teaopenapi.models.Config config = new com.aliyun.teaopenapi.models.Config();
        config.protocol = "https";
        config.regionId = "central";
        return new com.aliyun.dingtalkyida_1_0.Client(config);
    }

    @Override
    public String createYiDaXM(String dingUserid,String mapJson) throws Exception{

        //创建宜搭表单（项目管理表单）
        com.aliyun.dingtalkyida_1_0.Client client = createClient();
        com.aliyun.dingtalkyida_1_0.models.SaveFormDataHeaders saveFormDataHeaders = new com.aliyun.dingtalkyida_1_0.models.SaveFormDataHeaders();
        //钉钉token授权码
        saveFormDataHeaders.xAcsDingtalkAccessToken = accessTokenService.getAccessToken();
        com.aliyun.dingtalkyida_1_0.models.SaveFormDataRequest saveFormDataRequest = new com.aliyun.dingtalkyida_1_0.models.SaveFormDataRequest()
                //宜搭应用秘钥（宜搭使用的是钉钉token授权码）
                .setSystemToken("WP966ZB1A4S3UPKK874E098BVPXN2EHYMP28LZE")
                //宜搭表单ID（项目管理表单）
                .setFormUuid("FORM-OS566L91S9Y3NHB9CFHMU6HZEQAJ22C6NP28L4")
                //TODO 发起人：用户useId
                .setUserId(dingUserid)
                //宜搭应用编码
                .setAppType("APP_NOQGHDKUDXD7VDWZUC6I")
                //TODO 宜搭表单控件传参：json格式，同时对应表单的控件id进行传值创建表单数据
                .setFormDataJson(mapJson);
        try {
            client.saveFormDataWithOptions(saveFormDataRequest, saveFormDataHeaders, new com.aliyun.teautil.models.RuntimeOptions());
        } catch (
                TeaException err) {
            if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                // err 中含有 code 和 message 属性，可帮助开发定位问题
            }

        } catch (Exception _err) {
            TeaException err = new TeaException(_err.getMessage(), _err);
            if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                // err 中含有 code 和 message 属性，可帮助开发定位问题
            }

        }

        return "创建宜搭项目表单成功！";
    }

    @Override
    public String createYiDaRW(String dingUserid,String mapJson) throws Exception{

        com.aliyun.dingtalkyida_1_0.Client client = createClient();
        StartInstanceHeaders startInstanceHeaders = new StartInstanceHeaders();
        startInstanceHeaders.xAcsDingtalkAccessToken = accessTokenService.getAccessToken();
        StartInstanceRequest startInstanceRequest = new StartInstanceRequest()
                .setAppType("APP_NOQGHDKUDXD7VDWZUC6I")
                .setSystemToken("WP966ZB1A4S3UPKK874E098BVPXN2EHYMP28LZE")
                .setUserId(dingUserid)
                .setLanguage("zh_CN")
                .setFormUuid("FORM-2J6666D178X3VAUFCFHXRCEX9QF825S63R28LI")
                .setFormDataJson(mapJson);
//                //流程编码
//                .setProcessCode("TPROC--EF6Y4xxx")
//                //发起人所在部门ID
//                .setDepartmentId("18295");
        try {
            client.startInstanceWithOptions(startInstanceRequest, startInstanceHeaders, new RuntimeOptions());
        } catch (TeaException err) {
            if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                // err 中含有 code 和 message 属性，可帮助开发定位问题
            }

        } catch (Exception _err) {
            TeaException err = new TeaException(_err.getMessage(), _err);
            if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                // err 中含有 code 和 message 属性，可帮助开发定位问题
            }

        }

        return "创建宜搭任务表单成功！";
    }

}
